# todo:
# - package  ICSharpCode.SharpZipLib.dll as an external dep ¿is it _really_ needed?
# - ¿should package  libikvm-native.so  ???
#       $ rpm -qf /usr/lib/libikvm-native.so
#       mono-devel-2.0.1-12.fc10.i386
# - study the ability of copiling after whole removal off dlls
# - study the ability of copiling after whole removal of jars
# - study the ability of copiling after whole removal of zips
# - study about using the original non modifiedsources for Source1 and Source2
# - enhancing the ikvm.build file for faster package debugging
# - generate?  /usr/share/pkgconfig/ikvm.pc
# - should I install the own jar files anywhere?
# - what about the tools?
#
# done:
# - is needed the JVM.dll included in the ikvm's binary distribution ikvmbin-0.38.0.2.zip... seems it's only for Win32

Name:           ikvm
Version:        0.38.0.2
Release:        1%{?dist}
Summary:        An implementation of Java for Mono

Group:          Development/Languages
License:        BSD
URL:            http://www.ikvm.net/
Source0:        http://downloads.sourceforge.net/%{name}/%{name}-%{version}.zip
Source1:        http://downloads.sourceforge.net/ikvm/openjdk6-b12-stripped.zip
Source2:        http://www.frijters.net/classpath-0.95-stripped.zip
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  nant, java-1.6.0-openjdk-devel, mono-nunit22, mono-devel
#Requires:       

%description
This package provides IKVM.NET, an open source Java compatibility
layer for Mono, which includes a Virtual Machine, a bytecode compiler,
and various class libraries for Java, as well as tools for Java and
Mono interoperability.

%package devel
Summary:        Development files for ikvm
Group:          Development/Libraries
Requires:       %{name} = %{version}-%{release} pkgconfig

%description devel
Development files for ikvm


%prep
%setup -q
%setup -q -n %{name}-%{version} -T -D -b 1
%setup -q -n %{name}-%{version} -T -D -b 2

nant clean

find . -name "*.dll" # -exec rm {} \;
#./bin/ICSharpCode.SharpZipLib.dll

find . -name "*.jar" # -exec rm {} \;
#./classpath/mscorlib.jar
#./classpath/IKVM.Runtime.jar
#./classpath/System.jar

find . -name "*.zip" # -exec rm {} \;
#./openjdk/vfs.zip
#./openjdk/java/util/zip

%build
nant all

%install
%{__rm} -rf %{buildroot}
%{__mkdir_p} %{buildroot}%{_libdir}/%{name}

install -p bin/IKVM.AWT.WinForms.dll %{buildroot}%{_libdir}/%{name}
install -p bin/ikvmstub.exe  %{buildroot}%{_libdir}/%{name}
install -p bin/ikvm.exe  %{buildroot}%{_libdir}/%{name}
install -p bin/IKVM.Runtime.dll  %{buildroot}%{_libdir}/%{name}
install -p bin/IKVM.Runtime.JNI.dll  %{buildroot}%{_libdir}/%{name}
install -p bin/IKVM.OpenJDK.ClassLibrary.dll  %{buildroot}%{_libdir}/%{name}
install -p bin/ikvmc.exe  %{buildroot}%{_libdir}/%{name}
install -p bin/libikvm-native.so  %{buildroot}%{_libdir}/%{name}
install -p bin/ICSharpCode.SharpZipLib.dll  %{buildroot}%{_libdir}/%{name}


#create launch wrappers script
%{__mkdir_p} %{buildroot}%{_bindir}

cat > %{buildroot}%{_bindir}/ikvmstub <<EOF
#!/bin/sh
mono  %{_libdir}/%{name}/ikvmstub.exe
EOF

cat > %{buildroot}%{_bindir}/ikvm <<EOF
#!/bin/sh
mono  %{_libdir}/%{name}/ikvm.exe
EOF

cat > %{buildroot}%{_bindir}/ikvmc <<EOF
#!/bin/sh
mono  %{_libdir}/%{name}/ikvmc.exe
EOF

#make our launch wrapper executable
chmod +x %{buildroot}/%{_bindir}/*


%clean
rm -rf %{buildroot}

%files 
%defattr (-,root,root,-)
%doc LICENSE THANKYOU HOWTO 
%{_bindir}/*
%{_libdir}/*

%files devel
%defattr(-,root,root,-)
## %{monodir}/pkgconfig/ikvm.pc

%changelog

* Sat Mar 28 2009 Ismael Olea <ismael@olea.org> 0.38.0.2-1
- first version 

